<?php
/**
 *
 *  Accountlist.php
 *
 * @author   dlo
 * @copyright  CYBERDAY GmbH
 * @license    CYBERDAY GmbH
 * @version    0.1
 * @since    22.03.2016
 *
 *                          _(__)_        V
 *                        '-e e -'__,--.__)
 *                         (o_o)        )
 *                            \. /___.  |
 *                            ||| _)/_)/
 *                         dlo//_(/_(/_(
 *
 **/
namespace Cyberday\ApiItRechtKanzlei\Helper\Action;

use Cyberday\ApiItRechtKanzlei\Model\Api\Request\DataObject as RequestDataObject;
use Cyberday\ApiItRechtKanzlei\Helper\AbstractAction;
use Cyberday\ApiItRechtKanzlei\Helper\Data;
use Cyberday\ApiItRechtKanzlei\Model\Api\Exception as ApiException;
use Magento\Framework\App\Helper\Context;
use Magento\Framework\ObjectManagerInterface;
use Magento\Framework\DataObject;

class Accountlist extends AbstractAction
{
    /**
     *
     * @var \Magento\Framework\ObjectManagerInterface
     */
    protected $_objectManager;

    /**
     *
     * @var \Cyberday\ApiItRechtKanzlei\Helper\Data
     */
    protected $_helper;

    /**
     *
     * @param Context $context
     * @param ObjectManagerInterface $objectManager
     * @param Data $helper
     */
    public function __construct(Context $context, ObjectManagerInterface $objectManager, Data $helper)
    {
        parent::__construct($context);
        $this->_objectManager = $objectManager;
        $this->_helper = $helper;
    }

    /**
     *
     * {@inheritDoc}
     * @see \Cyberday\ApiItRechtKanzlei\Helper\ActionInterface::proccess()
     */
    public function proccess(RequestDataObject $requestDataObject, DataObject $dataObject)
    {

        $stores = [];

        /*@var $storeCollection \Magento\Store\Model\ResourceModel\Store\Collection */
        $storeCollection = $this->_objectManager->create('Magento\Store\Model\ResourceModel\Store\Collection');
        $storeCollection->setLoadDefault(false);

        foreach ($storeCollection as $store) {
            /*@var $store \Magento\Store\Model\Store */
            $temp = [
                'accountid' => $store->getStoreId(),
                'accountname' => $store->getName()
            ];
            $stores[] = $temp;
        }

        $dataObject->unsetData();
        $dataObject->setAccountlist($stores);
    }
}
