<?php
/**
 *
 *  Exception.php
 *
 * @author   dlo
 * @copyright  CYBERDAY GmbH
 * @license    CYBERDAY GmbH
 * @version    0.1
 * @since    21.03.2016
 *
 *                          _(__)_        V
 *                        '-e e -'__,--.__)
 *                         (o_o)        )
 *                            \. /___.  |
 *                            ||| _)/_)/
 *                         dlo//_(/_(/_(
 *
 **/

namespace Cyberday\ApiItRechtKanzlei\Model\Api;

class Exception extends \Exception
{
    const ERROR_API_VERSION = 1;
    const ERROR_AUTH = 2;
    const ERROR_TOKEN = 3;
    const ERROR_LAW_TYPE = 4;
    const ERROR_LAW_TEXT = 5;
    const ERROR_LAW_HTML = 6;
    const ERROR_LAW_PDF = 7;
    const ERROR_LAW_PDF_HASH = 8;
    const ERROR_LANGUAGE = 9;
    const ERROR_ACTION = 10;
    const ERROR_USER_ACCOUNT_ID = 11;
    const ERROR_XML = 12;
    const ERROR_LAW_COUNTRY = 17;
    
    const ERROR_OTHER = 99;
    
    /**
     *
     * @param string $message
     * @param int $code
     * @param mixed $previous
     */
    public function __construct($message = null, $code = null, $previous = null)
    {
        if ($code == null) {
            $code = self::ERROR_OTHER;
        }

        parent::__construct($message, $code, $previous);
    }
}
