<?php

/**
 * Mageplaza
 *
 * NOTICE OF LICENSE
 *
 * This source file is subject to the mageplaza.com license that is
 * available through the world-wide-web at this URL:
 * https://www.mageplaza.com/LICENSE.txt
 *
 * DISCLAIMER
 *
 * Do not edit or add to this file if you wish to upgrade this extension to newer
 * version in the future.
 *
 * @category    Mageplaza
 * @package     Mageplaza_EmailAttachments
 * @copyright   Copyright (c) Mageplaza (https://www.mageplaza.com/)
 * @license     https://www.mageplaza.com/LICENSE.txt
 */

/**
 *
 *  Message.php
 *  https://raw.githubusercontent.com/mageplaza/magento-2-email-attachments/master/Mail/Message.php
 *
 * @author   dlo
 * @version    0.1
 * @since    27.06.2019
 *
 *                          _(__)_        V
 *                        '-e e -'__,--.__)
 *                         (o_o)        )
 *                            \. /___.  |
 *                            ||| _)/_)/
 *                         dlo//_(/_(/_(
 *
 **/


namespace Cyberday\ApiItRechtKanzlei\Model\Rewrite\Framework\Mail;


use Magento\Framework\Mail\MailMessageInterface;
use Cyberday\ApiItRechtKanzlei\Traits\MailMessageTrait;
use Cyberday\ApiItRechtKanzlei\Traits\MailMessageTraitPrivate;
use Cyberday\ApiItRechtKanzlei\Traits\MailMessageTraitProtected;

// >=M2.2.8
if(interface_exists('\Magento\Framework\Mail\MailMessageInterface')) {
    $objectManager = \Magento\Framework\App\ObjectManager::getInstance();
    $helper = $objectManager->get('Cyberday\ApiItRechtKanzlei\Helper\Data');
    if($helper->versionCompare('2.3.4','>=') || $helper->versionCompare('2.3.3-p1','==')) {
        // >=M2.3.4 || 2.3.3-p1
        class Message extends \Magento\Framework\Mail\Message implements MailMessageInterface
        {
            use MailMessageTrait, MailMessageTraitProtected;
        }
    } else {
        class Message extends \Magento\Framework\Mail\Message implements MailMessageInterface
        {
            use MailMessageTrait, MailMessageTraitPrivate;
        }
    }
} else {
    //<=M2.2.7
    class Message extends \Magento\Framework\Mail\Message 
    {
    }
}