<?php
/**
 *
 *  OrderSender.php
 *
 * @author   dlo
 * @copyright  CYBERDAY GmbH
 * @license    CYBERDAY GmbH
 * @version    0.1
 * @since    23.03.2016
 *
 *                          _(__)_        V
 *                        '-e e -'__,--.__)
 *                         (o_o)        )
 *                            \. /___.  |
 *                            ||| _)/_)/
 *                         dlo//_(/_(/_(
 *
 **/
namespace Cyberday\ApiItRechtKanzlei\Model\Rewrite\Order\Email\Sender;

use Cyberday\ApiItRechtKanzlei\Helper\Data;
use Magento\Payment\Helper\Data as PaymentHelper;
use Magento\Sales\Model\Order;
use Magento\Sales\Model\Order\Email\Container\OrderIdentity;
use Magento\Sales\Model\Order\Email\Container\Template;
use Magento\Sales\Model\Order\Email\Sender;
use Magento\Sales\Model\ResourceModel\Order as OrderResource;
use Magento\Sales\Model\Order\Address\Renderer;
use Magento\Framework\Event\ManagerInterface;
use \Magento\Sales\Model\Order\Email\Sender\OrderSender as MagentoOrderSender;
use \Throwable;
use \Exception;

class OrderSender extends MagentoOrderSender
{

    /**
     *
     * @var \Cyberday\ApiItRechtKanzlei\Helper\Data
     */
    protected $_helper;
    
    /**
     *
     * @param Template $templateContainer
     * @param OrderIdentity $identityContainer
     * @param Order\Email\SenderBuilderFactory $senderBuilderFactory
     * @param \Psr\Log\LoggerInterface $logger
     * @param PaymentHelper $paymentHelper
     * @param OrderResource $orderResource
     * @param \Magento\Framework\App\Config\ScopeConfigInterface $globalConfig
     * @param Renderer $addressRenderer
     * @param ManagerInterface $eventManager
     * @param Data $helper
     */
    public function __construct(Template $templateContainer, OrderIdentity $identityContainer, \Magento\Sales\Model\Order\Email\SenderBuilderFactory $senderBuilderFactory, \Psr\Log\LoggerInterface $logger, Renderer $addressRenderer, PaymentHelper $paymentHelper, OrderResource $orderResource, \Magento\Framework\App\Config\ScopeConfigInterface $globalConfig, ManagerInterface $eventManager, Data $helper)
    {
        parent::__construct($templateContainer, $identityContainer, $senderBuilderFactory, $logger, $addressRenderer, $paymentHelper, $orderResource, $globalConfig, $eventManager);
        $this->_helper = $helper;
    }

    /**
     *
     * {@inheritDoc}
     * @see \Magento\Sales\Model\Order\Email\Sender\OrderSender::prepareTemplate()
     */
    protected function prepareTemplate(Order $order)
    {
        parent::prepareTemplate($order);
        
        try {
            $helper = $this->_helper;
            
            $store = $order->getStore();
            $store_id = $store->getStoreId();
    
            $templateVars = $this->templateContainer->getTemplateVars();
            $templateVars['attachments'] = $helper->getPdfsOrderEmail($store_id);
            $this->templateContainer->setTemplateVars($templateVars);
        } catch (Exception $exception) {
            $this->logger->critical($exception);
        } catch (Throwable $exception) {
            $this->logger->critical($exception);
        }
    }
}
