<?php
/**
 *
 *  TransportBuilderOldTrait.php
 *
 * @author   dlo
 * @version    0.1
 * @since    27.06.2019
 *
 *                          _(__)_        V
 *                        '-e e -'__,--.__)
 *                         (o_o)        )
 *                            \. /___.  |
 *                            ||| _)/_)/
 *                         dlo//_(/_(/_(
 *
 **/

namespace Cyberday\ApiItRechtKanzlei\Traits;

use Magento\Framework\Mail\MessageInterface;
use Magento\Framework\App\TemplateTypesInterface;
use Magento\Framework\Exception\LocalizedException;
use Magento\Framework\Mail\MessageInterfaceFactory;
use Magento\Framework\Mail\TransportInterfaceFactory;
use Magento\Framework\ObjectManagerInterface;
use Magento\Framework\Phrase;
use Magento\Framework\Mail\Template\FactoryInterface;
use Magento\Framework\Mail\Template\SenderResolverInterface;
use Cyberday\ApiItRechtKanzlei\Helper\Data;

trait TransportBuilderOldTrait {
    /**
     * @var Data
     */
    protected $helper;

    /**
     * @param FactoryInterface $templateFactory
     * @param MessageInterface $message
     * @param SenderResolverInterface $senderResolver
     * @param ObjectManagerInterface $objectManager
     * @param TransportInterfaceFactory $mailTransportFactory
     * @param MessageInterfaceFactory $messageFactory
     *
     * @SuppressWarnings(PHPMD.UnusedFormalParameter)
     */
    public function __construct(
        FactoryInterface $templateFactory,
        MessageInterface $message,
        SenderResolverInterface $senderResolver,
        ObjectManagerInterface $objectManager,
        TransportInterfaceFactory $mailTransportFactory,
        MessageInterfaceFactory $messageFactory = null,
        Data $helper
    ) {
        parent::__construct(
             $templateFactory,
             $message,
             $senderResolver,
             $objectManager,
             $mailTransportFactory,
             $messageFactory
        ) ;
        $this->helper = $helper;
    }

    /**
     * for M <= 2.2.7
     * @param string $body
     * @param string $filename
     * @param string $mimeType
     * @param string $disposition
     * @param string $encoding
     * @return \Cyberday\ApiItRechtKanzlei\Model\Rewrite\Framework\Mail\Template\TransportBuilder
     */
    public function addAttachment($body, $filename = null, $mimeType = \Zend_Mime::TYPE_OCTETSTREAM, $disposition = \Zend_Mime::DISPOSITION_ATTACHMENT, $encoding = \Zend_Mime::ENCODING_BASE64)
    {
        $this->message->createAttachment($body, $mimeType, $disposition, $encoding, $filename);
        return $this;
    }

    /**
     *  @return MessageInterface
     */
    public function getMessage()
    {
        return $this->message;
    }

    /**
     * After all parts are set, add them to message body.
     *
     * @return $this
     * @throws \Magento\Framework\Exception\LocalizedException
     */
    protected function prepareMessage()
    {
        parent::prepareMessage();

        if($this->helper->versionCompare('2.2.8','>=')) {
            $this->message->setPartsToBody();
        }

        return $this;
    }
}