<?php

/**
 *
 *  TransportBuilderTrait.php
 *
 * @author   dlo
 * @version    0.1
 * @since    27.06.2019
 *
 *                          _(__)_        V
 *                        '-e e -'__,--.__)
 *                         (o_o)        )
 *                            \. /___.  |
 *                            ||| _)/_)/
 *                         dlo//_(/_(/_(
 *
 **/

namespace Cyberday\ApiItRechtKanzlei\Traits;

use Magento\Framework\App\TemplateTypesInterface;
use Magento\Framework\Exception\LocalizedException;
use Magento\Framework\Mail\MessageInterfaceFactory;
use Magento\Framework\Mail\TransportInterfaceFactory;
use Magento\Framework\ObjectManagerInterface;
use Magento\Framework\Phrase;
use Magento\Framework\Mail\Template\FactoryInterface;
use Magento\Framework\Mail\Template\SenderResolverInterface;
use Cyberday\ApiItRechtKanzlei\Helper\Data;
use Magento\Framework\Mail\EmailMessageInterface;

trait TransportBuilderTrait
{

    protected $attachments = [];

    /**
     * After all parts are set, add them to message body.
     *
     * @return $this
     * @throws \Magento\Framework\Exception\LocalizedException
     */
    protected function prepareMessage()
    {
        parent::prepareMessage();
        $this->setBodyAttachments();
        $this->message->setPartsToBody();
        return $this;
    }

    public function addBodyAttachment($content, $fileName, $fileType, $encoding = '8bit')
    {
        $this->attachments[] = [
            $content, $fileName, $fileType, $encoding
        ];
    }

    public function setBodyAttachments()
    {
        foreach ($this->attachments as $attachment) {
            $this->message->setBodyAttachment(
                $attachment[0],
                $attachment[1],
                $attachment[2],
                $attachment[3]
            );
        }
    }
}
